<template>
  <div class="relative w-full">
    <div id="theChart" class="the-chart"></div>
    <img width="56" height="8" src="@/assets/images/flash-logotype.svg" class="absolute left-3 bottom-12" />
  </div>
</template>

<script>
const STEPS = {
  '1h': 120000,
  '1d': 3600000,
  '7d': 86400000,
  '30d': 86400000,
};

const months = {
  en: {
    0: 'Jan',
    1: 'Feb',
    2: 'Mar',
    3: 'Apr',
    4: 'May',
    5: 'Jun',
    6: 'Jul',
    7: 'Aug',
    8: 'Sep',
    9: 'Oct',
    10: 'Nov',
    11: 'Dec',
  },
  cn: {
    0: '一月',
    1: '二月',
    2: '三月',
    3: '四月',
    4: '五月',
    5: '六月',
    6: '七月份',
    7: '八月份',
    8: '9月',
    9: '10月',
    10: '11月',
    11: '12月',
  },
  ru: {
    0: 'Янв',
    1: 'Фев',
    2: 'Мар',
    3: 'Апр',
    4: 'Май',
    5: 'Июн',
    6: 'Июл',
    7: 'Авг',
    8: 'Сен',
    9: 'Окт',
    10: 'Нояб',
    11: 'Дек',
  },
};

import * as am4core from '@amcharts/amcharts4/core';
import * as am4charts from '@amcharts/amcharts4/charts';
import am4themes_animated from '@amcharts/amcharts4/themes/animated';

export default {
  name: 'TheChart',

  props: {
    timerange: {
      type: String,
      default: '1h',
    },

    loading: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      chart: null,
      valueAxis: null,

      gridLinesCount: 4,

      chartData: [],
    };
  },

  computed: {
    statistics() {
      return this.$store.state.auth.analytics.chart;
    },

    isAuthorized() {
      return this.$store.state.auth.isAuthorized;
    },

    userProjects() {
      return this.$store.state.auth.userProjects;
    },

    locale() {
      return this.$i18n.locale;
    },

    isDataFilled() {
      return Boolean(this.$props.statistics?.length);
    },

    currentApiKey() {
      return this.$store.state.auth.currentApiKey;
    },
  },

  watch: {
    statistics() {
      if (this.chart?.dispose) this.chart.dispose();
      setTimeout(() => {
        this.createChart();
      }, 0);
    },

    timerange() {
      if (this.chart?.dispose) this.chart.dispose();
    },

    currentApiKey() {
      if (this.chart?.dispose) this.chart.dispose();
    },
  },

  beforeDestroy() {
    if (this.chart?.dispose) this.chart.dispose();
  },

  methods: {
    createChart() {
      this.createData();
      this.initChart('theChart', this.chartData);
    },

    createData() {
      let data;

      if (this.statistics?.length) {
        data = this.createFilledData();
      } else {
        data = this.createDefaultData();
      }

      this.chartData = [...data];
    },

    createDefaultData() {
      const data = [];
      let step, stepAmount;
      const currentDate = new Date();

      if (this.timerange === '1h') {
        step = 600000;
        stepAmount = 6;
      } else if (this.timerange === '1d') {
        step = 10800000;
        stepAmount = 8;
      } else if (this.timerange === '7d') {
        step = 86400000;
        stepAmount = 7;
      } else if (this.timerange === '30d') {
        step = 432000000;
        stepAmount = 5;
      }

      for (let i = -1; i < stepAmount + 1; i++) {
        data.unshift({
          value: 0,
          date: new Date(currentDate.getTime() - i * step + (i === -1 || i === stepAmount ? 60000 : 0)),
        });
      }

      return data;
    },

    createFilledData() {
      let data = [];
      this.statistics.forEach((item, index) => {
        if (index === 0 || (index !== 0 && item.timestamp > this.statistics[index - 1].timestamp))
          data.push({
            value: item.value,
            date: new Date(item.timestamp * 1000),
          });
      });

      data = [
        {
          date: new Date(data[0].date.getTime() - STEPS[this.timerange]),
          value: data[0].value,
        },
        ...data,
        {
          date: new Date(data[data.length - 1].date.getTime() + STEPS[this.timerange]),
          value: data[data.length - 1].value,
        },
      ];

      return data;
    },

    initChart(id, data) {
      am4core.useTheme(am4themes_animated);
      const chart = am4core.create(id, am4charts.XYChart);
      this.chart = chart;

      chart.paddingLeft = 0;
      chart.paddingRight = 0;
      chart.paddingTop = 2;
      chart.paddingBottom = 0;
      chart.background.fill = am4core.color('#111E2F');

      chart.numberFormatter.numberFormat = '####';
      if (this.timerange === '1h') chart.dateFormatter.dateFormat = 'HH:mm';
      if (this.timerange === '1d') chart.dateFormatter.dateFormat = 'HH:mm';
      if (this.timerange === '7d') chart.dateFormatter.dateFormat = 'dd MMM';
      if (this.timerange === '30d') chart.dateFormatter.dateFormat = 'dd MMM';

      const dateAxis = chart.xAxes.push(new am4charts.DateAxis());
      dateAxis.renderer.labels.template.fill = am4core.color('#405069');
      dateAxis.renderer.labels.template.fontSize = 12;
      dateAxis.renderer.labels.template.fontWeight = 600;
      dateAxis.renderer.labels.template.paddingTop = 11;
      dateAxis.renderer.grid.template.strokeOpacity = 0;
      dateAxis.startLocation = 1;
      dateAxis.endLocation = 0;
      dateAxis.tooltipDateFormat = '{date}';
      if (this.timerange === '30d') dateAxis.renderer.minGridDistance = 50;
      else dateAxis.renderer.minGridDistance = 40;
      dateAxis.tooltip.disabled = true;

      const valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
      this.valueAxis = valueAxis;
      valueAxis.renderer.labels.template.disabled = true;
      valueAxis.renderer.grid.template.stroke = am4core.color('#213651');
      valueAxis.renderer.grid.template.strokeOpacity = 1;
      valueAxis.renderer.grid.template.strokeWidth = 2;
      valueAxis.strictMinMax = true;
      valueAxis.cursorTooltipEnabled = false;
      valueAxis.renderer.grid.template.disabled = true;
      valueAxis.renderer.labels.template.disabled = true;
      valueAxis.renderer.labels.template.fontSize = 12;
      valueAxis.renderer.labels.template.fontWeight = 500;
      // valueAxis.renderer.labels.template.color = am4core.color('#405069');

      const gradient = new am4core.LinearGradient();
      gradient.addColor(am4core.color('rgba(0, 102, 255, 0.16)'));
      gradient.addColor(am4core.color('rgba(0, 102, 255, 0))'));
      gradient.rotation = 90;

      const series = chart.series.push(new am4charts.LineSeries());
      series.dataFields.valueY = 'value';
      series.dataFields.dateX = 'date';
      series.stroke = am4core.color('#0066FF');
      series.tensionX = 0.8;
      // series.tensionY = 0;
      series.strokeWidth = 2;
      series.fill = gradient;
      series.fillOpacity = 1;

      chart.cursor = new am4charts.XYCursor();
      chart.cursor.lineX.stroke = am4core.color('#595959');
      chart.cursor.lineX.strokeOpacity = 0;
      chart.cursor.lineX.strokeDasharray = '10';
      chart.cursor.lineY.stroke = am4core.color('#595959');
      chart.cursor.lineY.strokeOpacity = 0;
      chart.cursor.lineY.strokeDasharray = '10';
      chart.cursor.behavior = 'none';

      // data ===================================

      let maxValue = 0;
      let minValue = data[0].value;

      data.forEach((item) => {
        if (item.value > maxValue) maxValue = item.value;
      });

      data.forEach((item) => {
        if (item.value < minValue) minValue = item.value;
      });

      valueAxis.renderer.baseGrid.disabled = true;

      if (maxValue === 0) valueAxis.min = -(maxValue / 4) ? -(maxValue / 3) : -1000;
      else {
        const percent = (maxValue - minValue) / 100;
        valueAxis.min = minValue - percent * 3;
      }

      valueAxis.baseValue = -(maxValue / 4) ? -(maxValue / 3) : -1000;
      valueAxis.max = maxValue ? maxValue * 1.05 : 3000;

      const step = (valueAxis.max - valueAxis.min) / this.gridLinesCount;
      for (let i = 0; i < this.gridLinesCount; i++) {
        let range = valueAxis.axisRanges.create();
        range.value = valueAxis.min + i * step;
        range.label.disabled = true;
      }

      const seriesTooltip = new am4core.Tooltip();
      series.tooltip = seriesTooltip;
      seriesTooltip.background.pointerLength = 6;
      seriesTooltip.background.pointerBaseWidth = 10;
      seriesTooltip.getFillFromObject = false;
      seriesTooltip.background.fill = am4core.color('#0C1521');
      seriesTooltip.background.fillOpacity = 1;
      seriesTooltip.background.strokeWidth = 0;
      seriesTooltip.background.cornerRadius = 6;
      seriesTooltip.label.fontSize = 12;
      seriesTooltip.label.fontWeight = 700;
      seriesTooltip.label.paddingTop = 7;
      seriesTooltip.label.paddingBottom = 6;
      seriesTooltip.label.paddingLeft = 12;
      seriesTooltip.label.paddingRight = 12;
      // seriesTooltip.ignoreBounds = true;

      seriesTooltip.dy = -6;
      seriesTooltip.pointerOrientation = 'down';
      series.tooltipText = '{value} [#7587A3]{date}[/] ';
      seriesTooltip.background.filters.clear();

      const bullet = series.bullets.push(new am4core.Circle());
      bullet.radius = 5;
      bullet.fill = am4core.color('#0066FF');
      bullet.strokeWidth = 2;
      bullet.stroke = am4core.color('#132235');
      bullet.scale = 0;
      const hoverState = bullet.states.create('hover');
      hoverState.properties.scale = 1;

      chart.data = data;
    },
  },
};
</script>

<style lang="scss">
.the-chart {
  height: 172px;
}

g[transform='translate(0,151)'] {
  display: none;
}
</style>
